#ifndef _FRAMEWORK_H
#define _FRAMEWORK_H
 
#include "vector.h"
#include "glincl.h"


#define DATA_DIRECTORY "~/svn/data/"
#define MOUSE_BUTTON_COUNT 8

class Camera;

class Framework {
 private:
  Camera* camera;
  
  int movement [4];
  
  Uint32 lastFrame;
  Uint32 currFrame;
    
  Uint8* keys; // This variable will be used in the keyboard routine
  bool mouseDown[MOUSE_BUTTON_COUNT];

 public:
  Framework();
  ~Framework();
  
  void initModule();
  bool mainLoop();
  bool draw(float dt);
  float tick();
  bool keyHandler();

  static void* initGui(void* argv);

  void printHelp(void) const;
};
#endif /* _FRAMEWORK_H */
